library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity long_multiplier is
    port (
        clk : in std_logic;
        a : in std_logic_vector(17 downto 0);
        b : in std_logic_vector(35 downto 0);
        p : out std_logic_vector(35 downto 0)    
    );
end long_multiplier;

architecture Behavioral of long_multiplier is
    signal r_a : std_logic_vector(17 downto 0);
    signal r_b : std_logic_vector(35 downto 0);     
    signal r_p : std_logic_vector(53 downto 0);
    signal r_p_d1 : std_logic_vector(53 downto 0); -- r_p zakasnjen za jedan takt (izlaz)
    
    attribute retiming_backward : integer;
    attribute retiming_backward of r_p : signal is 1;
begin
    INPUT_REG_PROC: process (clk) is
    begin
        if rising_edge(clk) then
            r_a <= a;
            r_b <= b;
        end if;    
    end process INPUT_REG_PROC;
    
    MUL_PROC: process (clk) is
    begin
        if rising_edge(clk) then
            r_p <= std_logic_vector(signed(r_a)*signed(r_b));
--            r_p_d1 <= r_p; -- otkomentarisati za dodatni registar
        end if;    
    end process MUL_PROC;
    
    -- zameniti za dodatni registar
--    p <= r_p_d1(r_p_d1'length - 1 downto r_p_d1'length - p'length);
    p <= r_p(r_p_d1'length - 1 downto r_p_d1'length - p'length);
end Behavioral;
